cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .yarn/

variables:
  REPO_NAME: gitlab.com/$CI_PROJECT_PATH
  GSG_RELEASE_BRANCHES: master

stages:
  - version
  - build
#  - test
  - build-image
  - deploy

before_script:
  - echo "Start CI/CD"

version:
  stage: version
  image: alpine:latest
  before_script:
    - apk add wget
    - wget https://juhani.gitlab.io/go-semrel-gitlab/download/v0.21.1/release
    - chmod +x release
  script:
    - ./release next-version --allow-current > .next-version
  artifacts:
    paths:
      - .next-version
  cache:
    paths:
      - ./release
  only:
    - master

build:
  stage: build
  image: trion/ng-cli
  before_script:
    - yarn install --cache-folder .yarn/ --prefer-offline --production=false
    - echo "RELEASE_URL=https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/jobs/$CI_JOB_ID/artifacts/dist/" > build_info
    - echo "RELEASE_DESC=\"Micro-Service Front\"" >> build_info
    - echo "RELEASE_SHA=$CI_COMMIT_SHA" >> build_info
    - echo "RELEASE_VERSION=$(<.next-version)" >> build_info
  script:
    - ng build --prod
  artifacts:
    expire_in: 1 day
    paths:
      - dist/
      - node_modules/
      - build_info

#test:karma:
#  stage: test
#  image: trion/ng-cli-karma
#  allow_failure: false
#  script:
#    - ng test --code-coverage --progress false --watch false
#  coverage: '/Lines \W+: (\d+\.\d+)%.*/'
#  artifacts:
#    paths:
#      - coverage/
#
#test:e2e:
#  stage: test
#  image: trion/ng-cli-e2e
#  allow_failure: false
#  script:
#    - ng e2e
#
#test:nglint:
#  stage: test
#  image: trion/ng-cli
#  script:
#    - ng lint

build-image:
  stage: build-image
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
    IMAGE_TAG: $CI_REGISTRY_IMAGE
  services:
    - docker:dind
  script:
    - rm -f release_info
    - mv build_info release_info
    - . release_info

    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG .
    - docker tag $IMAGE_TAG $IMAGE_TAG:${CI_COMMIT_SHORT_SHA}
    - docker tag $IMAGE_TAG $IMAGE_TAG:latest
    - docker push $IMAGE_TAG

    - ./release changelog
    - ./release commit-and-tag CHANGELOG.md release_info
  cache:
    paths:
      - ./release
  only:
    - master

k8s-deploy:
  image: google/cloud-sdk
  stage: deploy
  script:
    - echo "$KUBE_CONFIG" > kubeconfig
    - kubectl --kubeconfig kubeconfig apply -f deployment.yml --namespace=e-victime
    - kubectl -n e-victime rollout restart deploy app-frontend
#    - kubectl -n e-victime set image deployment/app-frontend app-frontend=registry.gitlab.com/uf-web/frontend/app:${CI_COMMIT_SHORT_SHA} --record
  only:
    - master

after_script:
  - echo "End CI/CD"
